#include <stdio.h>

#include "plugins.h"
#include "plugin_macros.h"

#ifdef WIN32
#include <windows.h>

DECLARE_FUNC(void, hello, (void));
DECLARE_VAR(int, a);
DECLARE_VAR(int, b);
DECLARE_PTR(Plugin, P);

#define a (*pa)
#define b (*pb)

#else
#include "my_app.h"
#endif


static void add ()
{
  hello();
  LOAD_PTR(Plugin, P);
  printf ("name=%s\n", P->name);
  printf ("description=%s\n\n", P->description);
  printf ("%d + %d = %d\n", a, b, a+b);
}

int init_plugin (Plugin *p)
{
  LOAD_FUNCC(hello);
  LOAD_VARC(int, a);
  LOAD_VARC(int, b);

  p->name = "Add";
  p->description = "Add two integers.";
  p->plugin_cb = add;
  P = p;

  return TRUE;
}
