#include <stdio.h>

#include "plugins.h"
#include "plugin_macros.h"

#ifdef WIN32
#include <windows.h>

DECLARE_VAR(int, a);
DECLARE_VAR(int, b);
DECLARE_PTR(Plugin, P);

#define a (*pa)
#define b (*pb)

#else
#include "my_app.h"
#endif

static void multiply ()
{
  LOAD_PTR(Plugin, P);
  printf ("name=%s\n", P->name);
  printf ("description=%s\n\n", P->description);
  printf ("%d * %d = %d\n", a, b, a*b);
}

int init_plugin (Plugin *p)
{
  LOAD_VARC(int, a);
  LOAD_VARC(int, b);

  p->name = "Multiply";
  p->description = "Multiply two integers.";
  p->plugin_cb = multiply;
  P = p;

  return TRUE;
}
